CREATE OR REPLACE PACKAGE PATIENT_DATA_SERVICES AS

function get_patient_id
( p_first_name in varchar2
, p_last_name  in varchar2
) return number
;

function get_patient_record
( p_patient_id in number
) return  patient_t
;

END PATIENT_DATA_SERVICES;
/

CREATE OR REPLACE PACKAGE BODY PATIENT_DATA_SERVICES AS

function get_patient_id
( p_first_name in varchar2
, p_last_name  in varchar2
) return number
 AS
  l_ptt_id number;
  BEGIN
    select ptt.id
    into   l_ptt_id
    from   patients ptt
    where  ptt.first_name = p_first_name
    and    ptt.last_name  = p_last_name
    ;
    RETURN l_ptt_id;
  END get_patient_id;

function get_patient_record
( p_patient_id in number
) return  patient_t
is   
  l_patient patient_t;
  l_physicalcharacteristic physicalcharacteristic;
  l_physicalcharacteristic_BMI physicalcharacteristic;
begin
  select patient_t(ptt.first_name, ptt.last_name, ptt.birth_date , null, ptt.gender , PHYSICALCHARACTERISTIC_TBL_T())
  into   l_patient
  from   patients ptt
  where  ptt.id = p_patient_id
  ;
  l_patient.initials := 'Q.E.D.';
  l_physicalcharacteristic := physicalcharacteristic( to_date('12-09-2010','DD-MM-YYYY'), 'Body Weight', '76','kg');
  l_physicalcharacteristic_bmi := physicalcharacteristic( to_date('11-07-2010','DD-MM-YYYY'), 'BMI', '32','kg/m2');
  l_patient.physical_characteristics := PHYSICALCHARACTERISTIC_TBL_T(l_physicalcharacteristic_bmi, l_physicalcharacteristic);
  return l_patient;
end get_patient_record;


END PATIENT_DATA_SERVICES;
/
